<template>
  <div class="app-container">
    <el-row :gutter="20">
      <el-col :span="4">
<!--        <div class="head-container">-->
<!--          <el-input-->
<!--            v-model="deptName"-->
<!--            placeholder="请输入部门名称"-->
<!--            clearable-->
<!--            size="small"-->
<!--            prefix-icon="el-icon-search"-->
<!--            style="margin-bottom: 20px"-->
<!--          />-->
<!--        </div>-->
        <div class="head-container">
          <el-tree
            :data="deptOptions"
            :props="defaultProps"
            :expand-on-click-node="false"
            :filter-node-method="filterNode"
            node-key="deptId"
            :default-expanded-keys="idArr"
            ref="tree"
            @node-click="handleNodeClick"
          />
        </div>
      </el-col>
      <el-col :span="20">
        <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
          <el-form-item label="档案名称" prop="archivesName">
            <el-input
              v-model="queryParams.archivesName"
              placeholder="请输入档案名称"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="档案编号" prop="archivesNum">
            <el-input
              v-model="queryParams.archivesNum"
              placeholder="请输入档案编号"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="归档日期" prop="archivesTime">
<!--            <el-date-picker clearable size="small" style="width: 200px"-->
<!--                            v-model="queryParams.archivesTime"-->
<!--                            type="date"-->
<!--                            value-format="yyyy-MM-dd"-->
<!--                            placeholder="选择日期">-->
<!--            </el-date-picker>-->
            <el-date-picker
              v-model="setime"
              size="small"
              style="width: 240px"
              value-format="yyyy-MM-dd"
              type="daterange"
              range-separator="-"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
            ></el-date-picker>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
        <el-row :gutter="10" class="mb8" style="margin-top: 0px;">
          <el-col :span="1.5">
            <el-button
              type="danger"
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
            >删除</el-button>
          </el-col>
        </el-row>
        <el-table border v-loading="loading" :data="archivesList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="序号" width="55" type="index" align="center">
            <template slot-scope="scope">
              <span>{{(queryParams.pageNum - 1) * queryParams.pageSize + scope.$index + 1}}</span>
            </template>
          </el-table-column>
          <!--      <el-table-column label="主键" align="center" prop="id" />-->
          <el-table-column label="所属部门" width="120" align="center" prop="deptName" />
          <el-table-column label="档案编号" align="center" prop="archivesNum"  :show-overflow-tooltip="true"  />
          <el-table-column label="档案名称" align="center" prop="archivesName"   :show-overflow-tooltip="true" />
          <el-table-column label="流程名称" align="center" prop="processName" width="120"/>
          <el-table-column label="所属分类" align="center" prop="archivesType" width="120"/>
          <el-table-column label="归档人" align="center" prop="rematk" width="120"/>
          <el-table-column label="归档日期"  align="center" prop="archivesTime" width="120">
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.archivesTime, '{y}-{m}-{d}') }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="openactform(scope.row.actkey,scope.row.id,scope.row.taskId)"
              >详情</el-button>
              <el-button
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click="handleDelete(scope.row)"
              >删除</el-button>
            </template>
          </el-table-column>
        </el-table>
        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getListtable"
        />
      </el-col>

    </el-row>


    <el-dialog id="actform" title="档案详情" :visible.sync="open" :before-close="cancel" append-to-body width="80%"
               top="10" height="90%">
      <!-- 动态引入组件-->
      <component :is="actForm" :data="details":actOpen="open" @getListtable="getListtable" ></component>
    </el-dialog>

  </div>
</template>

<script>
  import { getListright,listArchives, getArchives, delArchives, addArchives, updateArchives, exportArchives } from "@/api/system/archives/archives";
  import { getToken } from "@/utils/auth";
  // import { treeselect } from "@/api/system/dept";
  import Editor from '@/components/Editor';
  import "@riophae/vue-treeselect/dist/vue-treeselect.css";

  import { listDept } from "@/api/system/archives/column";
  import Treeselect from "@riophae/vue-treeselect";
  import "@riophae/vue-treeselect/dist/vue-treeselect.css";

  import {getStartFormKey,getCurrentFlowFormKey } from '@/api/activiti/process/startprocess'
  import log from '../../monitor/job/log'
  export default {
    name: "Archives",
    components: {
      Editor,
      Treeselect
    },
    data() {
      return {
        setime:[],
        idArr:[100,101],
        data:undefined,
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        dqbumen:'',
        dqname:'',
        actForm: null,
        actOpen: false,
        details:{getactkey: '',
          formId:'',
          flg:'2'},
        //下拉选框
        doc: [],
        options: [],
        // 部门名称
        deptName: undefined,
        // 部门树选项
        deptOptions: [],
        defaultProps: {
          children: "children",
          label: "deptName"
        },
        // 总条数
        total: 0,
        // 【请填写功能名称】表格数据
        archivesList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          archivesName: undefined,
          archivesNum: undefined,
          deptId: undefined,
          deptName: undefined,
          archivesType: undefined,
          archivesTime: undefined,
          state: undefined,
          rematk: undefined,
          actkey:undefined
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        }
      };
    },
    created() {
      this.getList();
      this.getListtable();
      // this.getTreeselect();
    },
    methods: {

      openactform(actkey,id,taskId) {
        this.open = true
        let vue = this
        actkey=actkey.split(":")[0];
        this.details.getactkey = actkey//动态传参到下面的页面
        this.details.formId = taskId//动态传参到下面的页面
        //this.details.formId = id//动态传参到下面的页面
        getStartFormKey(actkey).then(response => {
          var path = response.msg
          this.actForm = () => Promise.resolve().then(() => require(`@/views/${path}`))
        })
        return vue.actForm = this.actForm
      },

      /** 查询部门下拉树结构 */
      // getTreeselect() {
      //   treeselect().then(response => {
      //     this.deptOptions = response.data;
      //     console.log(response.data)
      //   });
      // },
      // 筛选节点
      filterNode(value, data) {
        if (!value) return true;
        return data.leabel.indexOf(value) !== -1;
      },
      // 节点单击事件
      handleNodeClick(data) {
        console.log(data)
        this.queryParams.deptId = data.deptId;
        this.getListtable();
      },
      // getListeven(){
      //   getArchives
      // },

      getListtable(){
        this.queryParams.beginTime=this.setime[0];
        this.queryParams.endTime=this.setime[1];
        console.log(this.queryParams.beginTime)
        console.log(this.queryParams.endTime)
        getListright(this.queryParams).then(response => {
          console.log(response.rows)
          this.archivesList = response.rows;
          this.total = response.total;
        })
        // this.loading = true;
        // havedInfo(this.queryParams).then(response => {
        //   this.infoList = response.rows;
        //   this.total = response.total;
        //   this.loading = false;
        //   this.actOpen=false;
        // });
      },
      /** 查询文档列表 */
      getList() {
        this.loading = true;
        listDept(this.queryParams).then(response => {
          console.log(response.data)
          this.deptOptions = this.handleTree(response.data, "deptId");
          console.log(this.handleTree(response.data, "deptId"))
          this.loading = false;
        });
      },
      /** 转换文档数据结构 */
      normalizer(node) {
        if (node.children && !node.children.length) {
          delete node.children;
        }
        return {
          id: node.deptId,
          label: node.deptName,
          children: node.children
        };
      },

      handleChange(value) {
        this.form.documentType=  JSON.stringify(this.doc)
        console.log(value);
      },

      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: undefined,
          archivesName: undefined,
          archivesNum: undefined,
          deptId: undefined,
          deptName: undefined,
          archivesType: undefined,
          archivesTime: undefined,
          state: undefined,
          rematk: undefined,
          createBy: undefined,
          setime:undefined,
          createTime: undefined
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.queryParams.deptId = undefined;
        this.getListtable();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.setime="";
        this.resetForm("queryForm");
        this.queryParams.deptId = undefined;
        this.handleQuery();
        this.getList();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!=1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加档案";
      },
      /** 修改按钮操作 */
      // handleUpdate(row) {
      //   this.reset();
      //   this.open = true;
      //   const id = row.id || this.ids
      //   getArchives(id).then(response => {
      //     this.form = response.data;
      //     this.open = true;
      //     this.title = "档案详情";
      //   });
      // },
      /** 提交按钮 */
      submitForm: function() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != undefined) {
              updateArchives(this.form).then(response => {
                if (response.code === 200) {
                  this.msgSuccess("修改成功");
                  this.open = false;
                  this.getList();
                }
              });
            } else {
              addArchives(this.form).then(response => {
                if (response.code === 200) {
                  this.msgSuccess("新增成功");
                  this.open = false;
                  this.getList();
                }
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        console.log(row)
        console.log("aaaaa")
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除档案编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delArchives(ids);
        }).then(() => {
          this.getList();
          this.getListtable();
          this.msgSuccess("删除成功");
        }).catch(function() {});
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$confirm('是否确认导出所有【请填写功能名称】数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportArchives(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
      }
    },
    watch: {
      // 根据名称筛选部门树
      deptName(val) {
        this.$refs.tree.filter(val);
      }
    },
  };
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 10px !important;
  }
</style>
